/*************************************************************************
   Beycan KAHRAMAN            Bilgisayar Isletim Sistemleri    Odev-3
      040020337                     Yrd. Doc. Dr. A. Sima UYAR
*************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#define KEYSHM_TUGLA   10000        // Ortak Paylasimli Bellek Alani
#define SEMKEY_CATI    25317        // Semafor Catidaki Iscileri Bekler
#define SEM_ISCI1      21543        // Semafor Isci1
#define SEM_ISCI2      18965        // Semafor Isci2
#define ISCI_SAYISI    2            // Calisan Isci Sayisi
#define TOPLAM_TUGLA   250          // Catiya Tasinacak Toplam Kiremit
#define TASIYICI_YUKU  25           // Maksimum Tasiyici Yuku

void signal12 ( void ) {}

void sem_signal ( int semid, int val )
{
    struct sembuf semafor;

    semafor.sem_num=0;
    semafor.sem_op=val;
    semafor.sem_flg=1;
    semop(semid, &semafor,1);
}

void sem_wait ( int semid, int val )
{
    struct sembuf semafor;

    semafor.sem_num=0;
    semafor.sem_op=(-1*val);
    semafor.sem_flg=1;
    semop(semid, &semafor,1);
}

int main (void)
{
    int i, j, f = 1;
    int sem_cati = 0, sem_isci[2] = {0};
    int isci[ISCI_SAYISI], pba = 0, *sayi = NULL;

    signal ( 12, (void *) signal12 );

    printf ( "%d ser %d ser, ", TASIYICI_YUKU, TASIYICI_YUKU );
    printf ( "toplam %d kiremit cekilecektir.\n", TOPLAM_TUGLA );

    for ( i=0; i<ISCI_SAYISI; ++i )
    {
        if ( f > 0 )
            f = fork ();
        if ( f == -1 )
        {
            printf("Fork Hatasi...\n");
            exit ( 1 );
        }
        if ( f == 0 )
            break;
        else
            isci[i] = f; // iki isci olusturuldu
    }

    if ( f > 0 ) /* catidaki = anne */
    {
        // gerekli bellek alani ve semaforlar olusturuluyor
        sem_cati = semget ( SEMKEY_CATI, 1, 0700|IPC_CREAT );
        semctl ( sem_cati, 0, SETVAL, 0 );

        sem_isci[0] = semget ( SEM_ISCI1, 1, 0700|IPC_CREAT );
        semctl ( sem_isci[0], 0, SETVAL, 1 );

        sem_isci[1] = semget ( SEM_ISCI2, 1, 0700|IPC_CREAT );
        semctl ( sem_isci[1], 0, SETVAL, 1 );

        pba = shmget ( KEYSHM_TUGLA, sizeof(int), 0700|IPC_CREAT );
        sayi = (int *) shmat ( pba, 0, 0 );
        sayi[0] = 0;

        printf ( "Catidaki : 'Yapilacak Ise Karar Veriliyor," ) ;
        sleep (1); // iscilerin olusturulmasini bekle

/*************************************************************************
 Kodun bu kisminda catidaki ilk olarak calismasi gereken isciyi secer ve
   sonradan tum iscilere sinyal gondererek onmlari uyandirir. Bu islem 
   dongu icinde gerceklestirilerek istenen sayida kiremitin tasiyiciyi
   kullanarak belli sayida tasima sonucu yukari cikartilip bosaltilmasi 
             saglanmistir. (while dongusunun sonuna kadar)
*************************************************************************/

        sem_wait ( sem_isci[1], 1 );
        while ( sayi[0] < TOPLAM_TUGLA )
        {
            printf ( " Isciler Uyandiriliyor'\n" );
            fflush (stdout);
            for ( j=0; j<ISCI_SAYISI; ++j )
                kill ( isci[j], 12 );
            sem_wait ( sem_cati, ISCI_SAYISI );
            printf ( " Cati:'Cektim, Bosalttim(%d),", sayi[0] );
        }

        printf ( " Kiremitler Yeterli\nSonlaniyorum...'\n" );
        shmdt(sayi);
        shmctl ( pba, IPC_RMID, 0 );
        semctl ( sem_cati, 0, IPC_RMID, 0 );
        semctl ( sem_isci[0], 0, IPC_RMID, 0 );
        semctl ( sem_isci[1], 0, IPC_RMID, 0 );

        exit ( 0 );
    }
    else /* isciler = cocuk */
    {
        pause (); // isciler olusturuldu

        // semaforlar ve ortak bellek bolgelerine baglantilar kuruluyor
        sem_cati = semget(SEMKEY_CATI, 1, 0);
        sem_isci[0] = semget(SEM_ISCI1, 1, 0);
        sem_isci[1] = semget(SEM_ISCI2, 1, 0);
        pba = shmget ( KEYSHM_TUGLA, sizeof(int),0 );
        sayi = (int *) shmat ( pba, 0, 0 );

/*************************************************************************
        Asagidaki while dongusunun icinde istenen doldurma islemi
  gerceklestirilmistir. Burada sem_isci[i] semaforlari yardimiyla sirayla
 calisan bu isciler icin ayrica kritik bolge semaforu kullanilmasina gerek 
 yoktur. Gereksiz yere sistem cagrilariyla programimizi yavaslatmamaliyiz.
  Burada sirasiyla kendi girisimizi onledikten sonra, kiremit sayisi 
   artirilip diger isciye izin verilmektedir. Burada ayrica bir tasiyici 
   semaforu kullanmak da gereksiz sistem cagrilarina neden olacagindan 
  tercih edilmemistir. En son olarak da Tasiyici bir sonraki iscide veya 
    su anki iscide dolacaksa catidaki kisiye cekme izni verilmektedir.
*************************************************************************/

        while ( sayi[0] < TOPLAM_TUGLA )
        {
            sem_wait ( sem_isci[i], 1 );             // kendini onle
            sayi[0] ++;                              // kiremiti ekle
            printf ( "%d", i );
            fflush (stdout);
            sem_signal ( sem_isci[1-i], 1 );         // digerine izin ver

            if( (sayi[0]+TASIYICI_YUKU-1) % TASIYICI_YUKU > TASIYICI_YUKU-3 ||
                sayi[0] > TOPLAM_TUGLA-2 )
            { // son eklememizi yapiyorsak, catidakine haber ver
                sem_signal ( sem_cati, 1 );
                pause ();
            }
        }

        shmdt(sayi);
        sem_signal ( sem_cati, 1 ); // cocuklar yokediliyor
        exit ( 0 );
    }
    return ( 0 );
}
